package atc.safefly.communication.common.packet;

import java.io.IOException;


public interface ConnectorInterface {
	/**
	 * Deep connect for all subConnectors and open of local structures and
	 * threads
	 * 
	 * @return true if success, false otherwise
	 * @throws IOException
	 */
	public boolean connect() throws IOException;

	/**
	 * Deep dispose of all underlying connectors and close local structures and
	 * threads
	 */
	public void dispose();

	/**
	 * Clear and destroy local structures and interrupt threads
	 */
	public abstract void close();

	/**
	 * Check deep connection and update local isConnected indicator upon the
	 * subConnectors state
	 * 
	 * @return true if whole connection is ready, false otherwise
	 */
	public boolean isConnected();

}
