package atc.safefly.communication.common.packet;

public class PacketFactory {
	private static int MASK = 0xFFFF;
	private static PacketInterface[] registeredProducts = new PacketInterface[MASK];

	public static PacketInterface getPacket(short ID) {
		try {
			return registeredProducts[ID & 0xFFFF].getInstance();
		} catch (NullPointerException e) {
			throw new UnsupportedOperationException("No packet registered for ID: 0x"+Integer.toHexString(ID & 0xFFFF)
					+"\n Call static initialization of this packet in static block of SafeflyConnector!");
		}
	}

	public static void registerPacket(PacketInterface packetInstance) {
		int position = packetInstance.getApplicationID() & MASK;
		if (registeredProducts[position] != null) {
			throw new IllegalArgumentException("Wrong Class:" + packetInstance.getClass().getName() + "> " + registeredProducts[position].getClass().getName()
					+ " already registered under ID " + position);
		}

		registeredProducts[position] = packetInstance;
	}
}
