package atc.safefly.communication.common.serial;

import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.net.ServerSocket;
import java.net.Socket;


public class ServerSocketConnector extends AbstractSerialConnector {
	
	int port;	
	
	private ServerSocket serverSocket;
	
		
	public ServerSocketConnector(int port){
		super();
		this.port = port;
	}
	
	
	/** Note that this method blocks current thread until new connection to the server socket */
	@Override
	public boolean connect() {
		try {
			serverSocket = new ServerSocket(port);
			Socket socket = serverSocket.accept();
			System.out.println("Socket created, connection accepted "+port);
			Thread.sleep(100);
			out = socket.getOutputStream();
			in = socket.getInputStream();
			isConnected = true;
			return true;
		} catch (IOException e) {
			e.printStackTrace();
		} catch (InterruptedException e) {
			//Just return
		}
		return false;
	}

	@Override
	public void dispose() {
		try {
			isConnected = false;
			if (out != null) {
				out.close();
				out = null;
			}
			if (in != null) {
				in.close();
				in = null;
			}
			if (serverSocket != null) {
				serverSocket.close();
				serverSocket = null;
			}
		} catch (IOException e) {
			e.printStackTrace();
		}
	}


	@Override
	public String getPortName() {
		return "TCP port "+port;
	}
}
