package atc.safefly.communication.common.serial;

import java.io.IOException;
import java.net.InetAddress;
import java.net.Socket;
import java.net.UnknownHostException;


public class SocketSerialConnector extends AbstractSerialConnector {
	
	private static final int SOCKET_TIMEOUT = 500; //ms
	
	int port;
	private InetAddress address;

	private Socket socket;

	// private Process piracom = null;

	public SocketSerialConnector(int port) {
		super();
		this.port = port;
		try {
			address = InetAddress.getByAddress(new byte[] { 127, 0, 0, 1 });
		} catch (UnknownHostException e) {
			e.printStackTrace();
		}
	}

	public SocketSerialConnector(InetAddress address, int port) {
		super();
		this.port = port;
		this.address = address;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see atc.procerus.communication.SerialConnector#connect()
	 */
	@Override
	public boolean connect() {
		if (!isConnected) {
			try {
				socket = new Socket(address, port);
				socket.setSoTimeout(SOCKET_TIMEOUT);
				System.out.println("Socket created, connection accepted " + port);
				out = socket.getOutputStream();
				outLock = false;
				in = socket.getInputStream();
				inLock = false;
				isConnected = true;
				return true;
			} catch (IOException e) {
				e.printStackTrace();
			}
		}
		return isConnected;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see atc.procerus.communication.SerialConnector#dispose()
	 */
	@Override
	public void dispose() {
		try {
			isConnected = false;
			if (out != null) {
				out.close();
				out = null;
			}
			if (in != null) {
				in.close();
				in = null;
			}
			if (socket != null) {
				socket.close();
				socket = null;
			}
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	@Override
	public String getPortName() {
		return "TCP port "+port;
	}
}
