package atc.safefly.communication.test;

import java.net.InetAddress;
import java.net.UnknownHostException;
import java.nio.ByteBuffer;
import java.util.Scanner;

import atc.safefly.communication.common.serial.SocketSerialConnector;
import atc.safefly.communication.modem.MicrohardDiagnosticPacketConnector;

public class ModemDiagnosticTest {

	/**
	 * @param args
	 */
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		InetAddress adr = null;
		try {
			adr = InetAddress.getLocalHost();
//			adr = InetAddress.getByAddress(new byte[] { (byte) 192, (byte) 168,
//					2, (byte) 155 });
		} catch (UnknownHostException e) {
			e.printStackTrace();
			return;
		}

		MicrohardDiagnosticPacketConnector diag = new MicrohardDiagnosticPacketConnector(
				new SocketSerialConnector(adr, 5553));
		if(!diag.connect()){
			System.err.println("Diagnostic connection failed!");
			return;
		}
		Scanner sc = new Scanner(System.in);

		System.out.println("Return to send and Q to quit");
		String line;
		while (!(line = sc.nextLine()).equalsIgnoreCase("q")) {
			int ua = 0;
			try {
				ua = Integer.parseInt(line);
			} catch (Exception e) {
			}// Use default 0

			byte[] data = diag.getParametrsByID(new int[] { 105 }, ua);
			if (data != null) {
				System.out.println("Diagnostic data from "
						+ (ByteBuffer.wrap(data, 0, 2).getShort() & 0xFFFF));
				System.out.println();
				for (int i = 3; i < data.length; i++) {
					System.out.print((data[i] & 0xFF) + ", ");
				}
			} else {
				System.out.println("Modem " + ua + " not responses.");
			}
		}
		diag.dispose();
		sc.close();
	}

}
