package atc.safefly.communication.test;

import java.util.Arrays;
import java.util.Random;
import java.util.Scanner;

import atc.safefly.communication.common.SafeflyConnector;
import atc.safefly.communication.common.packet.Packet;
import atc.safefly.communication.common.packet.PacketConnectionOwner;
import atc.safefly.communication.common.packet.PacketInterface;
import atc.safefly.communication.common.serial.ServerSocketConnector;
import atc.safefly.communication.common.serial.SocketSerialConnector;
import atc.safefly.utils.ByteUtils;

public class SimpleModemTest {

	public static byte[] data = new byte[256];
	public static Random r = new Random();

	private static Object lock = new Object();

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		PacketConnectionOwner handler = new PacketConnectionOwner() {

			@Override
			public void incommingPacket(PacketInterface packet) {
				synchronized (lock) {
//					System.out.println("Redeived: "+ByteUtils.byteArrayToHexString(packet.getData()));
					if (Arrays.equals(packet.getData(), data)) {
						System.out.println(data.length + "\tBytes of data transmitted");
					} else {
						System.out.println(data.length + "\tBytes of data fail");
					}
					try {
						Thread.sleep(1000);
					} catch (InterruptedException e) {
						return;
					}
					lock.notify();
				}
			}
		};
		final SafeflyConnector line1 = new SafeflyConnector(new ServerSocketConnector(5555), handler);
		final SafeflyConnector line2 = new SafeflyConnector(new SocketSerialConnector(5555), handler);
		new Thread(new Runnable() {

			@Override
			public void run() {
				line1.connect();
			}
		}).start();
		try {
			Thread.sleep(1000);
		} catch (InterruptedException e) {
			e.printStackTrace();
			return;
		}
		if (!line2.connect()) {
			line1.dispose();
			line2.dispose();
			System.err.println("Lines connection failed!");
			return;
		}
		Scanner sc = new Scanner(System.in);

		Thread sendingThread = new Thread(new Runnable() {

			@Override
			public void run() {
				while (!Thread.interrupted()) {
					synchronized (lock) {
						r.nextBytes(data);
						line2.sendPacket(new Packet(Arrays.copyOf(data, data.length)));
						try {
							lock.wait();
						} catch (InterruptedException e) {
							return;
						}
					}
				}
			}
		});

		sendingThread.start();
		System.out.println("Return to send and Q to quit");
while (!sc.nextLine().equalsIgnoreCase("q")) {
		}
		sendingThread.interrupt();
		sc.close();
		line1.dispose();
		line2.dispose();
	}
}
