package atc.safefly.communication.utils;

import java.nio.ByteBuffer;

public abstract class ApplicationData {

	/** Returns bytes in SMALL ENDIAN*/
	public abstract byte[] getBytes();
	
	/** 
	 * Initialize own constants from the byte array
	 * @param bytes - byte array of the whole data packet
	 * @param from - first byte to read this data from
	 * @return number of bytes read
	 */
	public abstract void parseFromBytes(ByteBuffer bb, int length);
	
	/**
	 * Set data values.
	 * @param values
	 */
	public abstract void setValues(int ...values);
	
	public abstract int getGroupOrChannelId();
}
