package atc.safefly.communication.utils;

public class RssiInfo {
	
	protected int masterRssi;
	
	protected int slaveRssi;
	
	/** Address of slave modem - should be the same as plane's ID */
	protected int slaveAddress;
	

	/**
	 * RSSI info
	 * @param masterRssi - RSSI at master's modem (Ground Station)
	 * @param slaveRssi - RSSI at slave's modem (aircraft)
	 * @param slaveAddress - address of slave modem - should be the same as plane's ID
	 */
	public RssiInfo(int masterRssi, int slaveRssi, int slaveAddress) {
		this.masterRssi = masterRssi;
		this.slaveRssi = slaveRssi;
		this.slaveAddress = slaveAddress;
	}

	public int getMasterRssi() {
		return masterRssi;
	}

	public int getSlaveRssi() {
		return slaveRssi;
	}

	/**
	 * address of slave modem - should be the same as plane's ID
	 * @return
	 */
	public int getSlaveAddress() {
		return slaveAddress;
	}
	

}
